/**
 *
 * $Id: version.h 225 2005-08-13 00:39:47Z ko1 $
 * Create : K.S. 04/01/11 04:11:41
 *
 */

#ifndef _VERSION_H_INCLUDED_
#define _VERSION_H_INCLUDED_

#define MAJOR_VER   0
#define MINOR_VER   2
#define DEVEL_VER   3

/*****************/
/* configuration */
/*****************/

/* gcc ver. check */
#if defined(__GNUC__) && __GNUC__ >= 2

#ifdef OPT_TOKEN_THREADED_CODE
#ifdef OPT_DIRECT_THREADED_CODE
#undef OPT_DIRECT_THREADED_CODE
#endif
#endif

#else

/* disable threaded code options */
#ifdef OPT_DIRECT_THREADED_CODE
#undef OPT_DIRECT_THREADED_CODE
#endif
#ifdef OPT_TOKEN_THREADED_CODE
#undef OPT_TOKEN_THREADED_CODE
#endif
#endif

/* call threaded code */
#ifdef OPT_CALL_THREADED_CODE
#ifdef OPT_DIRECT_THREADED_CODE
#undef OPT_DIRECT_THREADED_CODE
#endif
#ifdef OPT_STACK_CACHING
#undef OPT_STACK_CACHING
#endif
#define YARV_AOT_COMPILED 1
#endif

/* likely */
#ifdef __GCC__
#define LIKELY(x)   (__builtin_expect(x, 1))
#define UNLIKELY(x) (__builtin_expect(x, 0))
#else
#define LIKELY(x)   ((x) == 1)
#define UNLIKELY(x) ((x) == 0)
#endif


#define YARVDEBUG 0
#define CPDEBUG   0
#define VMDEBUG   0
#define GCDEBUG   0

#endif	// _VERSION_H_INCLUDED_


