#include <ruby.h>
#include <node.h>
#include "yarvcore.h"

#ifndef _YARV_H_INCLUDED_
#define _YARV_H_INCLUDED_


VALUE yarv_yield _((VALUE val));

/* original API */
RUBY_EXTERN int yarvIsWorking;
#define IS_YARV_WORKING() (yarvIsWorking)
#define SET_YARV_START()  (yarvIsWorking = 1)
#define SET_YARV_STOP()   (yarvIsWorking = 0)

VALUE yarv_get_current_running_thread _(());

struct yarv_yield_data{
  yarv_thread_t *th;
  yarv_block_t *block;
  VALUE *pc;
  VALUE *sp;
  int argc;
  int local_size;
};

VALUE thread_yield_light_prepare _((VALUE self, int argc, VALUE *argv,
                                    struct yarv_yield_data *data));


#endif
